import { ValueObject } from '@libs/ddd';

/** Note:
 * Value Objects with multiple properties can contain
 * other Value Objects inside if needed.
 * */

export interface ScheduleProps {
  mon?: string;
  tue?: string;
  wed?: string;
  thu?: string;
  fri?: string;
  sat?: string;
  sun?: string;
}

export class Schedule extends ValueObject<ScheduleProps> {
  get mon(): string | undefined {
    return this.props.mon;
  }

  get tue(): string | undefined {
    return this.props.tue;
  }

  get wed(): string | undefined {
    return this.props.wed;
  }

  get thu(): string | undefined {
    return this.props.thu;
  }

  get fri(): string | undefined {
    return this.props.fri;
  }

  get sat(): string | undefined {
    return this.props.sat;
  }

  get sun(): string | undefined {
    return this.props.sun;
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  protected validate(props: ScheduleProps): void {
    return;
  }
}
