import { Injectable } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { DefaultParamsProviderPort } from '../core/ports/default-params-provider.port';
import { DefaultParams } from '../core/ports/default-params.type';

@Injectable()
export class DefaultParamsProvider implements DefaultParamsProviderPort {
  constructor(private readonly configService: ConfigService) {}
  getParams = (): DefaultParams => ({
    MON_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    TUE_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    WED_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    THU_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    FRI_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    SAT_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    SUN_MARGIN: parseInt(this.configService.get('DEPARTURE_MARGIN')),
    DRIVER: this.configService.get('ROLE') == 'driver',
    SEATS_PROPOSED: parseInt(this.configService.get('SEATS_PROPOSED')),
    PASSENGER: this.configService.get('ROLE') == 'passenger',
    SEATS_REQUESTED: parseInt(this.configService.get('SEATS_REQUESTED')),
    STRICT: this.configService.get('STRICT_FREQUENCY') == 'true',
    DEFAULT_TIMEZONE: this.configService.get('DEFAULT_TIMEZONE'),
  });
}
