import { AutoMap } from '@automapper/classes';
import { IsOptional, IsString } from 'class-validator';
import { CoordinatesDTO } from './coordinates.dto';

export class AddressDTO extends CoordinatesDTO {
  @IsOptional()
  @AutoMap()
  name?: string;

  @IsOptional()
  @IsString()
  @AutoMap()
  houseNumber?: string;

  @IsOptional()
  @IsString()
  @AutoMap()
  street?: string;

  @IsOptional()
  @IsString()
  @AutoMap()
  locality?: string;

  @IsOptional()
  @IsString()
  @AutoMap()
  postalCode?: string;

  @IsString()
  @AutoMap()
  country: string;
}
