import { ArgumentMetadata } from '@nestjs/common';
import { RpcValidationPipe } from '../../pipes/rpc.validation-pipe';
import { FindAdByIdRequestDTO } from '../../../modules/ad/interface/queries/find-ad-by-id/dtos/find-ad-by-id.request.dto';

describe('RpcValidationPipe', () => {
  it('should not validate request', async () => {
    const target: RpcValidationPipe = new RpcValidationPipe({
      whitelist: true,
      forbidUnknownValues: false,
    });
    const metadata: ArgumentMetadata = {
      type: 'body',
      metatype: FindAdByIdRequestDTO,
      data: '',
    };
    await target.transform(<FindAdByIdRequestDTO>{}, metadata).catch((err) => {
      expect(err.message).toEqual('Rpc Exception');
    });
  });
});
